# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServices::Mgmt::V2016_06_01
  module Models
    #
    # Certificate details representing the Vault credentials for ACS.
    #
    class ResourceCertificateAndAcsDetails < ResourceCertificateDetails

      include MsRestAzure


      def initialize
        @authType = "AccessControlService"
      end

      attr_accessor :authType

      # @return [String] ACS namespace name - tenant for our service.
      attr_accessor :global_acs_namespace

      # @return [String] Acs mgmt host name to connect to.
      attr_accessor :global_acs_host_name

      # @return [String] Global ACS namespace RP realm.
      attr_accessor :global_acs_rprealm


      #
      # Mapper for ResourceCertificateAndAcsDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AccessControlService',
          type: {
            name: 'Composite',
            class_name: 'ResourceCertificateAndAcsDetails',
            model_properties: {
              certificate: {
                client_side_validation: true,
                required: false,
                serialized_name: 'certificate',
                type: {
                  name: 'ByteArray'
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'friendlyName',
                type: {
                  name: 'String'
                }
              },
              issuer: {
                client_side_validation: true,
                required: false,
                serialized_name: 'issuer',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceId',
                type: {
                  name: 'Number'
                }
              },
              subject: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subject',
                type: {
                  name: 'String'
                }
              },
              thumbprint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'thumbprint',
                type: {
                  name: 'String'
                }
              },
              valid_from: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validFrom',
                type: {
                  name: 'DateTime'
                }
              },
              valid_to: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validTo',
                type: {
                  name: 'DateTime'
                }
              },
              authType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'authType',
                type: {
                  name: 'String'
                }
              },
              global_acs_namespace: {
                client_side_validation: true,
                required: true,
                serialized_name: 'globalAcsNamespace',
                type: {
                  name: 'String'
                }
              },
              global_acs_host_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'globalAcsHostName',
                type: {
                  name: 'String'
                }
              },
              global_acs_rprealm: {
                client_side_validation: true,
                required: true,
                serialized_name: 'globalAcsRPRealm',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
